/*
Copyright Caroline et Serge COUDÉ, (09/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/

package net.sergecoude.TbiGeneral;

import java.net.*;
import paulscode.sound.*;
import paulscode.sound.libraries.*;
import paulscode.sound.codecs.*;

public class OggPlayer { 
	
  private TbiApp _app;
  private SoundSystem _soundSystem = null;
  private String _fluxCourant = ""; 

  public OggPlayer(TbiApp app) {
    _app = app;
    try {
      SoundSystemConfig.addLibrary( LibraryJavaSound.class );
      SoundSystemConfig.setCodec( "ogg", CodecJOrbis.class );
    } catch( SoundSystemException e ) {
      _app.message("Impossible de charger le plugin audio Ogg...", _app.MESSAGE_ERREUR);
    }
    _soundSystem = new SoundSystem(_app);
  }

  public void play(URL url) {
    if (_soundSystem == null) {
      _app.message("Le système audio n'est pas démarré...", _app.MESSAGE_ERREUR);
      return;  
    }
    if (_soundSystem.playing()) 
      _soundSystem.stop(_fluxCourant);
    _fluxCourant = _soundSystem.quickPlay(true, url, url.toString(), false, 0, 0, 0, SoundSystemConfig.ATTENUATION_NONE, 0);
  }
  
  public void stop() {
    if (_soundSystem == null) {
      _app.message("Le système audio n'est pas démarré...", _app.MESSAGE_ERREUR);
      return;  
    }
    _soundSystem.stop(_fluxCourant);
    _fluxCourant = "";
  }

  public boolean pret() {
    if (_soundSystem == null) 
      return false;
    return _soundSystem.playing();
  }

}