/*
Copyright Caroline et Serge COUDÉ, (04/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/
package net.sergecoude.TbiGeneral;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.util.*;
import java.awt.image.*;

public class PanelJeuMulti extends PanelJeu {

  private final static long serialVersionUID = 1L;
  private Vector<JButton> _lesBoutonsPlateaux = null;
  private Vector<PanelJeu> _lesPlateaux = null;
  private JPanel _pBoutonsPlateaux = null;

  public PanelJeuMulti(TbiApp app) {
    super(app);
    _pBoutonsPlateaux = new JPanel();
    _pBoutonsPlateaux.setOpaque(false);
    _pMain.add(_pBoutonsPlateaux);
  }
  
  public void setEnchainement(Enchainement ench) {
    _lesBoutonsPlateaux = new Vector<JButton>();
    _lesPlateaux = new Vector<PanelJeu>();
    ench.reset();
    PanelJeu pj = ench.suivant();
    while (pj != null) {
      JButton bPlateau = getBoutonPlateau(ench.getIntitule(pj));
      _lesBoutonsPlateaux.addElement(bPlateau);
      _lesPlateaux.addElement(pj);
      pj = ench.suivant(); 
    }
    ench.reset();
  }
  
  @Override
  public void componentHidden(ComponentEvent e) {
    // on ne repasse pas _init à false
  }  

/*  @Override
  public void componentShown(ComponentEvent e) {
    super.componentShown(e);
    repaint();
  }*/  

 
 @Override
  public void agenceLesComposants() {
    _pBoutonsPlateaux.removeAll();
    Dimension dim = getDimBoutonTableau();  
    if (_lesBoutonsPlateaux != null) {
      _pBoutonsPlateaux.setLayout(new GridLayout(1, _lesBoutonsPlateaux.size(), 0, 0));
      for(int i = 0; i < _lesBoutonsPlateaux.size(); i++) { 
        _pBoutonsPlateaux.add(_lesBoutonsPlateaux.elementAt(i));
      }
      _pBoutonsPlateaux.setBounds(0, 0, _lesBoutonsPlateaux.size()*dim.width, dim.height);
    }
    _pBoutonsPlateaux.repaint();
  }
  
  @Override
  public Rectangle getBounds() {
    Dimension size = super.getSize();
    size.height -= _pBoutonsPlateaux.getSize().height;
    return new Rectangle(0, _pBoutonsPlateaux.getSize().height, size.width, size.height);
  } 
  
  public Dimension getDimBoutonTableau() {
    return new Dimension(40, 10);
  }
  
  public JButton getBoutonPlateau(String libelle) {
    JButton b = new JButton(libelle);
    b.setFont(new Font("Helvetica", Font.BOLD, 10));
    b.addActionListener(this);
    return b;
  }
  
  public PanelJeu getPlateau(JButton b) {
    if (_lesBoutonsPlateaux != null) 
      for(int i = 0; i < _lesBoutonsPlateaux.size(); i++) 
        if (_lesBoutonsPlateaux.elementAt(i) == b)
          return _lesPlateaux.elementAt(i);
    return null; 
  }
  
}    