/*
Copyright Caroline et Serge COUDÉ, (11/2011) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/

package net.sergecoude.TbiGeneral;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.imageio.*;
import javax.swing.*;
import java.io.*;

public class Souris extends JPanel {

  private final static long serialVersionUID = 1L;

	private TbiApp _app;
	private int _hauteur, _largeur;
	private BufferedImage _image = null;
	private int _xSpot, _ySpot;
  private Cursor _curseurSouris = null;
  private BufferedImage _imageSouris = null;

	public Souris(TbiApp app) {
    super();
		setLayout(null);
		_app = app;
 		try {
      _image = ImageIO.read(_app.getRessource("/souris.png"));
 		} catch (Exception e) {
      _app.log(e);
    }
    setTaille(_app.getTailleCurseur());
    setVisible(false);
    if (_curseurSouris == null) {
      Toolkit tk = Toolkit.getDefaultToolkit();
   		try {
        _imageSouris = ImageIO.read(_app.getRessource("/point.gif"));
        _curseurSouris = tk.createCustomCursor(_imageSouris, new Point(0, 0), "souris");
  		} catch (Exception e) {
  		  _app.log(e);
	    }
	  }
	  if (_curseurSouris != null)
      setCursor(_curseurSouris);
	}
	
	public void setTaille(int taille) {
    if (taille == 1) {
    		_largeur = 32;
    		_hauteur = 32;
        _xSpot = 5;
        _ySpot = 30;
    } else if (taille == 2) {
    		_largeur = 64;
    		_hauteur = 64;
        _xSpot = 10;
        _ySpot = 60;
    } else {
    		_largeur = 128;
    		_hauteur = 128;
        _xSpot = 20;
        _ySpot = 119;
    }     
		setSize(_largeur,_hauteur);
  }

	public int getLargeur() {
		return _largeur;
	}

	public int getHauteur() {
		return _hauteur;
	}
	
	public void paint(Graphics g) {
		Dimension d = getSize();
		if (_image != null)
    	g.drawImage(_image,0,0,d.width,d.height,this);
	}

	public Dimension getPreferredSize() {
		return new Dimension(_largeur,_hauteur);
	}

	public Dimension getMinimumSize() {
		return getPreferredSize();
	}

	public Dimension getMaximumSize() {
		return getPreferredSize();
	}
	
	@Override
  public void setLocation(int x, int y) {
    super.setLocation(x-_xSpot, y-_ySpot);
  }
 
}
 
