/*
Copyright Caroline et Serge COUDÉ, (02/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/

package net.sergecoude.TbiQuizzSonore;

import java.io.*;
import java.util.*;
import net.n3.nanoxml.*;
import net.sergecoude.TbiGeneral.*;

public class ExerciceQuizz extends Exercice  {

  private final static long serialVersionUID = 1L;
  private Element _bonneReponse = null;

  public ExerciceQuizz(Eleve e, int rang) {
    super(e, rang);
  }
  
  public ExerciceQuizz(Eleve eleve, IXMLElement xml) throws Exception {
    super(eleve, xml);
		IXMLElement xBonneReponse = xml.getFirstChildNamed("bonnereponse");
		if (xBonneReponse != null) {
		  _bonneReponse = new Element(xBonneReponse.getContent()); 
    } else {
      throw new Exception("La réponse correcte de l'enregistrement n'est pas indiquée...");
    }
  }  
  
  public void setSucces(int numExercice) {
  }
  
  public void setEchec(int numExercice) {
  }  

  public Enregistrement getNewEnregistrement(IXMLElement xml) throws Exception {
    _lesEnregistrements.add(new EnregistrementQuizz(xml));
    return getEnregistrement();
  }
  
  public void setBonneReponse(Element bonneReponse) {
    _bonneReponse = bonneReponse;
  }
  
  public Element getBonneReponse() {
    return _bonneReponse;
  }
  
  public String toXmlDebut() {
    return super.toXmlDebut() + "<bonnereponse>" + _bonneReponse.toString() + "</bonnereponse>";    
  }  

  public void addEnregistrement(Element eChoix, int duree, boolean succes) {
    _lesEnregistrements.add(new EnregistrementQuizz(_lesEnregistrements.size()+1, duree, succes, eChoix));
  }
  
  public String toString() {  
    String ret = "ExerciceQuizz " + _rang + " (" + (_dateStart.getTimeInMillis()/1000) + "-" + (_dateStop.getTimeInMillis()/1000) + ")\n";
    for(int e = 0; e < _lesEnregistrements.size(); e++)
      ret += "\t\t\t" + ((EnregistrementQuizz)(_lesEnregistrements.elementAt(e))).toString();
    return ret;
  }
    
}
	
  
